#include <stdio.h>

short int *premier;
typedef struct {
  unsigned int taille;
  unsigned int *t;}tab;

init_premiers(){
  int i,j;

  premier=(short int*)malloc(101*sizeof(short int));
  for(i=2;i<=100;i++) premier[i]=1;
  for(i=2;i<=7;i++)
  {
   j=2;
   while(i*j<=100) premier[i*j++]=0;
  }
}

int est_pair(int x){
  float y=x;
  return (y/2.0==x/2);
}

tab* sommes(int p){

tab *res;
int i;
float f=p;

res=(tab*)malloc(sizeof(tab));
res->taille=0;
res->t=(unsigned int*)malloc(sizeof(unsigned int));
for(i=2;i<=p/i;i++) if(f/i==p/i)
  {
    res->taille++;
    res->t=(unsigned int*)realloc(res->t,(res->taille+1)*sizeof(unsigned int));
    res->t[res->taille]=p/i+i;
  }
  return res;
}

tab* produits(int s){

tab *res;
int i;
float f=s;

res=(tab*)malloc(sizeof(tab));
res->taille=0;
res->t=(unsigned int*)malloc(sizeof(unsigned int));
for(i=1;i<=s/2;i++)
  {
    res->taille++;
    res->t=(unsigned int*)realloc(res->t,(res->taille+1)*sizeof(unsigned int));
    res->t[res->taille]=i*(s-i);
  }
  return res;
}


main(){

int i,j,k;
unsigned int x,y,s,p,s2,s1=0;
unsigned int p2,p1=0;
int produit,somme,cpt,cpts,cptp;
tab *tabs,*tabp;
int type_arret;

init_premiers();

printf("Deux nombres inconnus x et y. Deux personnes P et S en connaissent\n");
printf("respectivement le produit et la somme. Conversation entre P et S:\n");
printf("P:\"Je ne peux pas les trouver.\"\nS:\"Je le savais.\"\n");
printf("P:\"Eh bien alors je les connais.\"\nS:\"Donc moi aussi.\"\n");
printf("Que valent x et y ?\n\n");
printf("Entrez les nombres x et y que vous voulez tester :\n");
printf("(Ctrl+C Entree pour terminer)");
for(;;)
{
   printf("\nx ? "); scanf("%d",&x);
   printf("y ? "); scanf("%d",&y);
   produit=x*y; somme=x+y;
   type_arret=0;
   printf("Somme: %d    Produit: %d\n",somme,produit);

   /* TEST 1 */
   if (premier[x] && premier [y]) {type_arret=1; goto fin;}
   
   /* TEST 2 */
   for(i=2;i<=somme/2+1;i++) if(premier[i] && premier[somme-i])
     {type_arret=2; goto fin;}

   /* TEST 3 */
   cpts=0;
   tabs=sommes(produit);
   for(i=1;i<=tabs->taille;i++)
   {
     s=tabs->t[i];
     cpt=0;
     for(j=2;j<=s/2+1;j++)
     {
       if(premier[j] && premier[s-j])
       { cpt++; if (cpt>1) goto fin2; }
     }
     if (cpt==0) {s2=s1; s1=s; cpts++;}
     fin2:
   }
   if (cpts>1) {type_arret=3; goto fin;}
   if (cpts==0) {type_arret=4; goto fin;}
   free(tabs);

   /* TEST 4 */
   tabp=produits(somme);
   cptp=0;
   for(k=1;k<=tabp->taille;k++)
   {
     p=tabp->t[k];
     cpts=0;
     tabs=sommes(p);
     for(i=1;i<=tabs->taille;i++)
     {
       s=tabs->t[i];
       cpt=0;
       for(j=2;j<=s/2+1;j++)
       {
         if(premier[j] && premier[s-j])
         { cpt++; if (cpt>1) goto fin3;}
       }
       if (cpt==0) cpts++;
       fin3:
       free(tabs);
     }
     if (cpts==1) {p2=p1; p1=p; cptp++;}
   }
   if (cptp>1) {type_arret=5; goto fin;}
   if (cptp==0) {type_arret=6; goto fin;}
   /* Ici, x et y sont solutions, car il n'y a eu aucun saut vers "fin:".*/
   fin:
   switch (type_arret)
   {
   case 0: printf("C'est la solution de l'enigme !\n"); break;
   case 1: printf("%d et %d sont premiers, donc P peut tout de suite trouver les 2 nombres.\n",x,y);
           printf("(Erreur a la phrase 1.)\n"); break;
   case 2: printf("S peut imaginer un produit de deux nombres premiers (%d et %d), ce qui\nne peut pas lui permettre d'affirmer que P ne peut pas trouver.\n(Erreur a la ligne 2)\n",i,somme-i);
           break;
   case 3: printf("Parmi les sommes que P peut s'imaginer, il y en a plusieurs (par exemple %d\net %d) qui auraient permis a S de dire la deuxieme phrase.\nEn effet, ces deux sommes permettent d'imaginer toutes les deux des produits\nde nombres premiers.\n",s1,s2);
           printf("(Erreur a la phrase 3.)\n"); break;
   case 4: printf("Parmi les sommes que P peut s'imaginer, aucune ne permettrait a S de dire\nla deuxieme phrase\n(Erreur a la phrase 3.)\n");
           break; /* Ce cas n'arrive en theorie jamais */
   case 5: printf("S peut s'imaginer plusieurs produits pouvant donner l'implication\nligne 2=>ligne 3 (par exemple %d et %d). Or, pour qu'il trouve en ligne 4,\nil ne doit y avoir qu'un produit imaginable qui puisse convenir.\n",p1,p2);
           printf("(Erreur a la phrase 4.)\n"); break;
   case 6: printf("S ne peut s'imaginer aucun produit qui permette l'implication\nligne 2=>ligne 3.  Or, pour qu'il trouve en ligne 4,\nil doit y avoir un et un seul produit imaginable qui puisse convenir.\n");
           printf("(Erreur a la phrase 4.)\n"); break;
           /* Ce cas n'arrive en theorie jamais */
   default:;
            
   }
   free(tabs); free(tabp);
}

}
